# Information Extraction

## 🔖 Outline

To be added


## 🗒️ Notebooks

Set of notebooks associated with the chapter. 

1. **[Key Phrase Extraction](https://github.com/practical-nlp/practical-nlp/blob/master/Ch5/01_KPE.ipynb)**: Here we demonstrate Key Phrase Extraction using textacy.

2. **[NER using CRF](https://github.com/practical-nlp/practical-nlp/blob/master/Ch5/02_NERTraining.ipynb)**: Here we demonstrate how to perform NER using Conditional Random Fields.

3. **[NER issues in spaCy](https://github.com/practical-nlp/practical-nlp/blob/master/Ch5/03_NERIssues.ipynb)**: Here we illustrate some of the issues with the existing NER model in spacy and its sensitivity to text structure.

4. **[NER on CONLL using spaCy](https://github.com/practical-nlp/practical-nlp/blob/master/Ch5/04_NER_using_spaCy%20-%20CoNLL.ipynb)**: Here we demonstrate NER on the CONLL-NER dataset using spaCy.

5. **[NER on CONLL using BERT](https://github.com/practical-nlp/practical-nlp/blob/master/Ch5/05_BERT_CONLL_NER.ipynb)**: Here we demonstrate NER on the CONLL dataset using pytorch pre-trained BERT from the HuggingFace Transformers library. 

6. **[Entity Linking](https://github.com/practical-nlp/practical-nlp/blob/master/Ch5/06_EntityLinking-AzureTextAnalytics.ipynb)**: Here we demonstrate how to extract Named Entity linking information using Azure Text Analytics API.

7. **[Relation Extraction](https://github.com/practical-nlp/practical-nlp/blob/master/Ch5/07_REWatson.ipynb)**: Here we demonstrate Relation Extraction with IBM Watson.

8. **[Duckling](https://github.com/practical-nlp/practical-nlp/blob/master/Ch5/08_Duckling.ipynb)**: Here we demonstrate Temporal IE using duckling.


## 🖼️ Figures

Color figures as requested by the readers. 

![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-1.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-2.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-3.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-4.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-5.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-6.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-7.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-8.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-9.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-10.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-11.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-12.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-13.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-14.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-15.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-16.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-17.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-18.png)
![figure](https://github.com/practical-nlp/practical-nlp-figures/raw/master/figures/5-19.png)
